/*
 * ni-add-ip-dialog.h
 * This file is part of Network Inador
 *
 * Copyright (C) 2021 - Gatuno
 *
 * Network Inador is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Network Inador is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Network Inador; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, 
 * Boston, MA  02110-1301  USA
 */

#ifndef __NI_ADD_IP_DIALOG_H__
#define __NI_ADD_IP_DIALOG_H__

#include <glib-object.h>

#include "ni-ip.h"

G_BEGIN_DECLS

typedef struct _NIAddIPDialogClass NIAddIPDialogClass;
typedef struct _NIAddIPDialog NIAddIPDialog;
typedef struct _NIAddIPDialogPrivate NIAddIPDialogPrivate;

/*
 * Type declaration.
 */
#define NI_TYPE_ADD_IP_DIALOG (ni_add_ip_dialog_get_type ())
#define NI_ADD_IP_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), NI_TYPE_ADD_IP_DIALOG, NIAddIPDialog))
#define NI_ADD_IP_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), NI_TYPE_ADD_IP_DIALOG, NIAddIPDialogClass))
#define NI_IS_ADD_IP_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), NI_TYPE_ADD_IP_DIALOG))
#define NI_IS_ADD_IP_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), NI_TYPE_ADD_IP_DIALOG))
#define NI_ADD_IP_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), NI_TYPE_ADD_IP_DIALOG, NIAddIPDialogClass))

GType ni_add_ip_dialog_get_type (void);

struct _NIAddIPDialogClass {
	GtkDialogClass parent_class;
	
};

struct _NIAddIPDialog {
	GtkDialog parent_instance;
	
	NIAddIPDialogPrivate *priv;
};

/*
 * Method definitions.
 */
GtkWidget* ni_add_ip_dialog_new (int family);

gboolean ni_add_ip_dialog_get_address (NIAddIPDialog *dialog, struct_addr *addr, int *prefix);
gboolean ni_add_ip_dialog_has_p2p_address (NIAddIPDialog *dialog);
gboolean ni_add_ip_dialog_get_p2p_address (NIAddIPDialog *dialog, struct_addr *addr);
gboolean ni_add_ip_dialog_get_noprefix (NIAddIPDialog *dialog);

G_END_DECLS

#endif /* __NI_ADD_IP_DIALOG_H__ */

