/*
 * ni-interface-chooser-dialog.h
 * This file is part of Network Inador
 *
 * Copyright (C) 2021 - Gatuno
 *
 * Network Inador is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Network Inador is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Network Inador; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, 
 * Boston, MA  02110-1301  USA
 */

#ifndef __NI_INTERFACE_CHOOSER_DIALOG_H__
#define __NI_INTERFACE_CHOOSER_DIALOG_H__

#include <glib-object.h>

#include "ni-client.h"
#include "ni-interface-filter.h"

G_BEGIN_DECLS

typedef struct _NIInterfaceChooserDialogClass NIInterfaceChooserDialogClass;
typedef struct _NIInterfaceChooserDialog NIInterfaceChooserDialog;
typedef struct _NIInterfaceChooserDialogPrivate NIInterfaceChooserDialogPrivate;

/*
 * Type declaration.
 */
#define NI_TYPE_INTERFACE_CHOOSER_DIALOG (ni_interface_chooser_dialog_get_type ())
#define NI_INTERFACE_CHOOSER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), NI_TYPE_INTERFACE_CHOOSER_DIALOG, NIInterfaceChooserDialog))
#define NI_INTERFACE_CHOOSER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), NI_TYPE_INTERFACE_CHOOSER_DIALOG, NIInterfaceChooserDialogClass))
#define NI_IS_INTERFACE_CHOOSER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), NI_TYPE_INTERFACE_CHOOSER_DIALOG))
#define NI_IS_INTERFACE_CHOOSER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), NI_TYPE_INTERFACE_CHOOSER_DIALOG))
#define NI_INTERFACE_CHOOSER_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), NI_TYPE_INTERFACE_CHOOSER_DIALOG, NIInterfaceChooserDialogClass))

GType ni_interface_chooser_dialog_get_type (void);

struct _NIInterfaceChooserDialogClass {
	GtkDialogClass parent_class;
	
};

struct _NIInterfaceChooserDialog {
	GtkDialog parent_instance;
	
	NIInterfaceChooserDialogPrivate *priv;
};

enum NIInterfaceChooserOrder {
	NI_INTERFACE_CHOOSER_ORDER_INDEX,
	NI_INTERFACE_CHOOSER_ORDER_NAME,
	NI_INTERFACE_CHOOSER_ORDER_TYPE
};

/*
 * Method definitions.
 */
GtkWidget* ni_interface_chooser_dialog_new (NIClient *ni_client);

void ni_interface_chooser_dialog_set_filter (NIInterfaceChooserDialog *dialog, NIInterfaceFilter *filter);

guint ni_interface_chooser_dialog_get_index (NIInterfaceChooserDialog *dialog);

G_END_DECLS

#endif /* __NI_INTERFACE_CHOOSER_DIALOG_H__ */

