/*
 * ni-interface-filter.h
 * This file is part of NetworInador
 *
 * Copyright (C) 2021 - Félix Arreola Rodríguez
 *
 * NetworInador is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * NetworInador is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with NetworInador; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, 
 * Boston, MA  02110-1301  USA
 */

#ifndef __NI_INTERFACE_FILTER_H__
#define __NI_INTERFACE_FILTER_H__

#include <glib-object.h>

G_BEGIN_DECLS

#define NI_TYPE_INTERFACE_FILTER          (ni_interface_filter_get_type ())
#define NI_INTERFACE_FILTER(obj)          (G_TYPE_CHECK_INSTANCE_CAST ((obj), NI_TYPE_INTERFACE_FILTER, NIInterfaceFilter))
#define NI_IS_INTERFACE_FILTER(obj)       (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NI_TYPE_INTERFACE_FILTER))

typedef struct _NIInterfaceFilter     NIInterfaceFilter;
typedef struct _NIInterfaceFilterInfo NIInterfaceFilterInfo;

/*enum {
	NI_INTERFACE_FILTER_OR,
	NI_INTERFACE_FILTER_AND
} NIInterfaceFilterType;*/

struct _NIInterfaceFilterInfo {
	guint index;
	const gchar *name;
	guint type;
	guint master;
};

typedef gboolean (*NIInterfaceFilterFunc) (const NIInterfaceFilterInfo *filter_info, gpointer data);

GType ni_interface_filter_get_type (void) G_GNUC_CONST;

NIInterfaceFilter *       ni_interface_filter_new      (void);

void ni_interface_filter_add_name (NIInterfaceFilter *filter, const gchar *name, gboolean negated);
void ni_interface_filter_add_index (NIInterfaceFilter *filter, const guint index, gboolean negated);
void ni_interface_filter_add_type (NIInterfaceFilter *filter, const guint type, gboolean negated);
void ni_interface_filter_add_custom (NIInterfaceFilter *filter, NIInterfaceFilterFunc func, gpointer data, GDestroyNotify notify);

gboolean ni_interface_filter_filter (NIInterfaceFilter *filter, const NIInterfaceFilterInfo *filter_info);

G_END_DECLS

#endif /* __NI_INTERFACE_FILTER_H__ */

