/*
 * ni-window-interface.h
 * This file is part of NetworkInador
 *
 * Copyright (C) 2021 - Gatuno
 *
 * NetworkInador is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * NetworkInador is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with NetworkInador; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, 
 * Boston, MA  02110-1301  USA
 */

/* inclusion guard */
#ifndef __NI_WINDOW_INTERFACE_H__
#define __NI_WINDOW_INTERFACE_H__


#include <glib-object.h>

#include <sys/socket.h>
#include <netinet/in.h>

#include "ni-interface.h"

G_BEGIN_DECLS

typedef struct _NIWindowInterfaceClass NIWindowInterfaceClass;
typedef struct _NIWindowInterface NIWindowInterface;
typedef struct _NIWindowInterfacePrivate NIWindowInterfacePrivate;

/*
 * Type declaration.
 */
#define NI_TYPE_WINDOW_INTERFACE (ni_window_interface_get_type ())
#define NI_WINDOW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), NI_TYPE_WINDOW_INTERFACE, NIWindowInterface))
#define NI_WINDOW_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), NI_TYPE_WINDOW_INTERFACE, NIWindowInterfaceClass))
#define NI_IS_WINDOW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), NI_TYPE_WINDOW_INTERFACE))
#define NI_IS_WINDOW_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), NI_TYPE_WINDOW_INTERFACE))
#define NI_WINDOW_INTERFACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), NI_TYPE_WINDOW_INTERFACE, NIWindowInterfaceClass))

GType ni_window_interface_get_type (void);

struct _NIWindowInterfaceClass {
	GtkWindowClass parent_class;
	
};

struct _NIWindowInterface {
	GtkWindow parent_instance;
	
	NIWindowInterfacePrivate *priv;
};

/*
 * Method definitions.
 */
GtkWidget* ni_window_interface_new (NIInterface *ni_interface);

G_END_DECLS

#endif /* __NI_WINDOW_INTERFACE_H__ */
