/*
 * ni-window-route.h
 * This file is part of NetworkInador
 *
 * Copyright (C) 2021 - Gatuno
 *
 * NetworkInador is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * NetworkInador is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with NetworkInador; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, 
 * Boston, MA  02110-1301  USA
 */

/* inclusion guard */
#ifndef __NI_WINDOW_ROUTE_H__
#define __NI_WINDOW_ROUTE_H__


#include <glib-object.h>

#include <sys/socket.h>
#include <netinet/in.h>

#include "ni-client.h"
#include "ni-route.h"

G_BEGIN_DECLS

typedef struct _NIWindowRouteClass NIWindowRouteClass;
typedef struct _NIWindowRoute NIWindowRoute;
typedef struct _NIWindowRoutePrivate NIWindowRoutePrivate;

/*
 * Type declaration.
 */
#define NI_TYPE_WINDOW_ROUTE (ni_window_route_get_type ())
#define NI_WINDOW_ROUTE(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), NI_TYPE_WINDOW_ROUTE, NIWindowRoute))
#define NI_WINDOW_ROUTE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), NI_TYPE_WINDOW_ROUTE, NIWindowRouteClass))
#define NI_IS_WINDOW_ROUTE(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), NI_TYPE_WINDOW_ROUTE))
#define NI_IS_WINDOW_ROUTE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), NI_TYPE_WINDOW_ROUTE))
#define NI_WINDOW_ROUTE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), NI_TYPE_WINDOW_ROUTE, NIWindowRouteClass))

GType ni_window_route_get_type (void);

struct _NIWindowRouteClass {
	GtkWindowClass parent_class;
	
};

struct _NIWindowRoute {
	GtkWindow parent_instance;
	
	NIWindowRoutePrivate *priv;
};

/*
 * Method definitions.
 */
GtkWidget* ni_window_route_new (NIClient *ni_client, int family);

G_END_DECLS

#endif /* __NI_WINDOW_ROUTE_H__ */
