/*
 * resolv_manager.h
 * This file is part of Network-inador
 *
 * Copyright (C) 2023 - Félix Arreola Rodríguez
 *
 * Network-inador is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Network-inador is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Network-inador; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, 
 * Boston, MA  02110-1301  USA
 */

#ifndef __RESOLV_MANAGER_H__
#define __RESOLV_MANAGER_H__

#include "network-inador-private.h"
#include "struct_addr_union.h"
#include "resolv_conf_defs.h"
#include "interfaces.h"

void resolv_manager_init (NetworkInadorHandle *handle);
void resolv_manager_clear_entries_by_prog (NetworkInadorHandle *handle, const int iface_index, const char *prog);
void resolv_manager_process_resolvconf_entries (NetworkInadorHandle *handle, ResolvConfEntry *entries, int num_entries);
void resolv_manager_process_dhcp_nameservers (NetworkInadorHandle *handle, Interface *iface);
void resolv_manager_clear_dhcp_nameservers (NetworkInadorHandle *handle, Interface *iface);
//void resolv_manager_clear_tag_on_all (NetworkInadorHandle *handle);
//void resolv_manager_write (NetworkInadorHandle *handle);

#endif /* __RESOLV_MANAGER_H__ */

