/*
 * manager.h
 * This file is part of Network Inador
 *
 * Copyright (C) 2021 - Gatuno
 *
 * Network Inador is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Network Inador is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Network Inador; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, 
 * Boston, MA  02110-1301  USA
 */

#ifndef __MANAGER_H__
#define __MANAGER_H__

#include <stdint.h>

#include "common.h"

int manager_init (NetworkInadorHandle *handle);
void manager_send_event_interface_add (NetworkInadorHandle *handle, Interface *iface);
void manager_send_event_interface_del (NetworkInadorHandle *handle, uint32_t index);
void manager_send_event_interface_update (NetworkInadorHandle *handle, Interface *iface);
void manager_send_event_ip_add (NetworkInadorHandle *handle, IPAddr *ip_addr);
void manager_send_event_ip_del (NetworkInadorHandle *handle, IPAddr *ip_addr);
void manager_send_event_dhcp_change (NetworkInadorHandle *handle, InterfaceDHCPClientInfo *dhcpc);
void manager_send_event_route_add (NetworkInadorHandle *handle, Route *route);
void manager_send_event_route_del (NetworkInadorHandle *handle, Route *route);
void manager_send_event_route_update (NetworkInadorHandle *handle, Route *route);
void manager_send_event_route_table_del (NetworkInadorHandle *handle, RouteTable *rtable);
void manager_send_event_route_table_add (NetworkInadorHandle *handle, RouteTable *rtable);

#endif /* __MANAGER_H__ */

